Important: Please read the Qt Code of Conduct - https://forum.qt.io/topic/113070/qt-code-of-conduct

"pip install pyqt5" gives tons of errors. Why?



  • Hi,
    On Slackware instance I am running the following command:

    pip install pyqt5

    As a result, I get the following output with tons of errors:

    Collecting pyqt5
      Using cached PyQt5-5.15.0.tar.gz (3.3 MB)
      Installing build dependencies: started
      Installing build dependencies: finished with status 'done'
      Getting requirements to build wheel: started
      Getting requirements to build wheel: finished with status 'done'
        Preparing wheel metadata: started
        Preparing wheel metadata: still running...
        Preparing wheel metadata: finished with status 'error'
        ERROR: Command errored out with exit status 1:
         command: /usr/bin/python3 /usr/lib/python3.7/site-packages/pip/_vendor/pep517/_in_process.py prepare_metadata_for_build_wheel /tmp/tmpehic3amf
             cwd: /tmp/pip-install-fh1pxns1/pyqt5
        Complete output (1321 lines):
        Querying qmake about your Qt installation...
        /usr/lib/qt5/bin/qmake -query
        This is the GPL version of PyQt 5.15.0 (licensed under the GNU General Public License) for Python 3.7.3 on linux.
        Found the license file 'pyqt-gpl.sip'.
        Checking to see if the QtCore bindings can be built...
        /usr/lib/qt5/bin/qmake QtCore.pro
        Info: creating stash file /tmp/tmp0w3foywi/cfgtest_QtCore/.qmake.stash
        make
        g++ -c -pipe -O2 -march=i586 -mtune=i686 -std=gnu++11 -Wall -W -D_REENTRANT -fPIC -DQT_NO_DEBUG -DQT_CORE_LIB -I. -I../../pip-install-fh1pxns1/pyqt5/qpy/QtCore -isystem /usr/include/qt5 -isystem /usr/include/qt5/QtCore -I. -I/usr/lib/qt5/mkspecs/linux-g++ -o cfgtest_QtCore.o ../../pip-install-fh1pxns1/pyqt5/config-tests/cfgtest_QtCore.cpp
    
    
        g++ -c -pipe -O2 -march=i586 -mtune=i686 -std=gnu++11 -Wall -W -D_REENTRANT -fPIC -DQT_NO_DEBUG -DQT_XMLPATTERNS_LIB -DQT_NETWORK_LIB -DQT_CORE_LIB -I. -isystem /usr/include/qt5 -isystem /usr/include/qt5/QtXmlPatterns -isystem /usr/include/qt5/QtNetwork -isystem /usr/include/qt5/QtCore -I. -I/usr/lib/qt5/mkspecs/linux-g++ -o cfgtest_QtXmlPatterns.o cfgtest_QtXmlPatterns.cpp
        g++ -Wl,-O1 -o QtXmlPatterns cfgtest_QtXmlPatterns.o   -lQt5XmlPatterns -lQt5Network -lQt5Core -lpthread
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: warning: libicui18n.so.56, needed by /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so, not found (try using -rpath or -rpath-link)
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: warning: libicuuc.so.56, needed by /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so, not found (try using -rpath or -rpath-link)
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: warning: libicudata.so.56, needed by /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so, not found (try using -rpath or -rpath-link)
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `ucol_open_56'
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `u_strToLower_56'
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `ucnv_getStandardName_56'
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `ucnv_compareNames_56'
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `ucal_clone_56'
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `ucnv_getAlias_56'
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `uenum_next_56'
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `ucal_open_56'
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `ucol_setAttribute_56'
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `u_strToUpper_56'
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `ucnv_setSubstChars_56'
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `ucal_getTimeZoneDisplayName_56'
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `ucal_openCountryTimeZones_56'
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `ucnv_fromUnicode_56'
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `ucnv_open_56'
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `ucal_openTimeZones_56'
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `ucnv_countAliases_56'
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `u_errorName_56'
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `ucal_inDaylightTime_56'
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `uenum_close_56'
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `ucnv_getAvailableName_56'
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `ucal_close_56'
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `ucal_openTimeZoneIDEnumeration_56'
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `ucnv_getDefaultName_56'
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `ucal_getDSTSavings_56'
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `ucal_getDefaultTimeZone_56'
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `ucnv_toUnicode_56'
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `ucal_setMillis_56'
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `ucol_strcoll_56'
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `ucnv_close_56'
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `ucol_close_56'
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `ucol_getSortKey_56'
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `ucnv_countAvailable_56'
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `ucnv_getMaxCharSize_56'
        /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so: undefined reference to `ucal_get_56'
        collect2: error: ld returned 1 exit status
        Makefile:214: recipe for target 'QtXmlPatterns' failed
        make: *** [QtXmlPatterns] Error 1
        Checking to see if the dbus-python support should be built...
        The dbus-python package does not seem to be installed.
        These bindings will be built: Qt, pylupdate, pyrcc.
        Generating the Qt bindings...
        Generating the pylupdate bindings...
        _in_process.py: Q_PID is undefined
        
        ----------------------------------------
    ERROR: Command errored out with exit status 1: /usr/bin/python3 /usr/lib/python3.7/site-packages/pip/_vendor/pep517/_in_process.py prepare_metadata_for_build_wheel /tmp/tmpehic3amf Check the logs for full command output.
    

    What am I doing wrong? How shoul I install the corrsponding module for Python 3.7?


  • Moderators

    Him, and welcome!

    @glestwid said in "pip install pyqt5" gives tons of errors. Why?:

    I get the following output with tons of errors:

    When compiling any software, just focus on the first error. Once you fix that, many (or all) of the others will disappear.

    The line that contains your first error is:

    /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../../i586-slackware-linux/bin/ld: warning: libicui18n.so.56, needed by /usr/lib/gcc/i586-slackware-linux/5.3.0/../../../libQt5Core.so, not found (try using -rpath or -rpath-link)
    

    According to that message, you must install ICU 56.



  • @JKSH said in "pip install pyqt5" gives tons of errors. Why?:

    libicui18n

    Ok, will libicui18n67-67.1-3-omv4002.i686.rpm work as an up-to-date substitution for 56? Should I do anything else to make 67 working as 56?


  • Moderators

    @glestwid said in "pip install pyqt5" gives tons of errors. Why?:

    Ok, will libicui18n67-67.1-3-omv4002.i686.rpm work as an up-to-date substitution for 56? Should I do anything else to make 67 working as 56?

    Unfortunately, I don't think ICU 67 is not backwards-compatible with ICU 56.

    It looks like Slackware 14.2 (the latest stable release) contains ICU 56 but Slackware-Current (the development release) contains ICU 67.



  • Ok, I found missed sources for libicui, built abd deployed the lib , and now I'm getting another error while calling PIP:

    pip install pyqt5
    Collecting pyqt5
      Using cached PyQt5-5.15.0.tar.gz (3.3 MB)
      Installing build dependencies ... done
      Getting requirements to build wheel ... done
        Preparing wheel metadata ... error
        ERROR: Command errored out with exit status 1:
         command: /usr/bin/python3 /usr/lib/python3.7/site-packages/pip/_vendor/pep517/_in_process.py prepare_metadata_for_build_wheel /tmp/tmpngmrw6gt
             cwd: /tmp/pip-install-kl7346yk/pyqt5
        Complete output (31 lines):
        Traceback (most recent call last):
          File "/usr/lib/python3.7/site-packages/pip/_vendor/pep517/_in_process.py", line 126, in prepare_metadata_for_build_wheel
            hook = backend.prepare_metadata_for_build_wheel
        AttributeError: module 'sipbuild.api' has no attribute 'prepare_metadata_for_build_wheel'
        
        During handling of the above exception, another exception occurred:
        
        Traceback (most recent call last):
          File "/usr/lib/python3.7/site-packages/pip/_vendor/pep517/_in_process.py", line 280, in <module>
            main()
          File "/usr/lib/python3.7/site-packages/pip/_vendor/pep517/_in_process.py", line 263, in main
            json_out['return_val'] = hook(**hook_input['kwargs'])
          File "/usr/lib/python3.7/site-packages/pip/_vendor/pep517/_in_process.py", line 131, in prepare_metadata_for_build_wheel
            config_settings)
          File "/usr/lib/python3.7/site-packages/pip/_vendor/pep517/_in_process.py", line 159, in _get_wheel_metadata_from_wheel
            whl_basename = backend.build_wheel(metadata_directory, config_settings)
          File "/tmp/pip-build-env-bi1ma0qt/overlay/lib/python3.7/site-packages/sipbuild/api.py", line 51, in build_wheel
            project = AbstractProject.bootstrap('pep517')
          File "/tmp/pip-build-env-bi1ma0qt/overlay/lib/python3.7/site-packages/sipbuild/abstract_project.py", line 82, in bootstrap
            project.setup(pyproject, tool, tool_description)
          File "/tmp/pip-build-env-bi1ma0qt/overlay/lib/python3.7/site-packages/sipbuild/project.py", line 479, in setup
            self.apply_user_defaults(tool)
          File "project.py", line 62, in apply_user_defaults
            super().apply_user_defaults(tool)
          File "/tmp/pip-build-env-bi1ma0qt/overlay/lib/python3.7/site-packages/pyqtbuild/project.py", line 89, in apply_user_defaults
            super().apply_user_defaults(tool)
          File "/tmp/pip-build-env-bi1ma0qt/overlay/lib/python3.7/site-packages/sipbuild/project.py", line 225, in apply_user_defaults
            self.builder.apply_user_defaults(tool)
          File "/tmp/pip-build-env-bi1ma0qt/overlay/lib/python3.7/site-packages/pyqtbuild/builder.py", line 69, in apply_user_defaults
            "specify a working qmake or add it to PATH")
        sipbuild.pyproject.PyProjectOptionException
        ----------------------------------------
    ERROR: Command errored out with exit status 1: /usr/bin/python3 /usr/lib/python3.7/site-packages/pip/_vendor/pep517/_in_process.py prepare_metadata_for_build_wheel /tmp/tmpngmrw6gt Check the logs for full command output.
    

    What should I do now to have these issues fixed?


  • Moderators

    @glestwid Your first error is:

    AttributeError: module 'sipbuild.api' has no attribute 'prepare_metadata_for_build_wheel'

    Google this error message.



  • @glestwid said in "pip install pyqt5" gives tons of errors. Why?:

    Ok, I found missed sources for libicui, built abd deployed the lib , and now I'm getting another error while calling PIP:

    pip install pyqt5
    Collecting pyqt5
      Using cached PyQt5-5.15.0.tar.gz (3.3 MB)
      Installing build dependencies ... done
      Getting requirements to build wheel ... done
        Preparing wheel metadata ... error
        ERROR: Command errored out with exit status 1:
         command: /usr/bin/python3 /usr/lib/python3.7/site-packages/pip/_vendor/pep517/_in_process.py prepare_metadata_for_build_wheel /tmp/tmpngmrw6gt
             cwd: /tmp/pip-install-kl7346yk/pyqt5
        Complete output (31 lines):
        Traceback (most recent call last):
          File "/usr/lib/python3.7/site-packages/pip/_vendor/pep517/_in_process.py", line 126, in prepare_metadata_for_build_wheel
            hook = backend.prepare_metadata_for_build_wheel
        AttributeError: module 'sipbuild.api' has no attribute 'prepare_metadata_for_build_wheel'
        
        During handling of the above exception, another exception occurred:
        
        Traceback (most recent call last):
          File "/usr/lib/python3.7/site-packages/pip/_vendor/pep517/_in_process.py", line 280, in <module>
            main()
          File "/usr/lib/python3.7/site-packages/pip/_vendor/pep517/_in_process.py", line 263, in main
            json_out['return_val'] = hook(**hook_input['kwargs'])
          File "/usr/lib/python3.7/site-packages/pip/_vendor/pep517/_in_process.py", line 131, in prepare_metadata_for_build_wheel
            config_settings)
          File "/usr/lib/python3.7/site-packages/pip/_vendor/pep517/_in_process.py", line 159, in _get_wheel_metadata_from_wheel
            whl_basename = backend.build_wheel(metadata_directory, config_settings)
          File "/tmp/pip-build-env-bi1ma0qt/overlay/lib/python3.7/site-packages/sipbuild/api.py", line 51, in build_wheel
            project = AbstractProject.bootstrap('pep517')
          File "/tmp/pip-build-env-bi1ma0qt/overlay/lib/python3.7/site-packages/sipbuild/abstract_project.py", line 82, in bootstrap
            project.setup(pyproject, tool, tool_description)
          File "/tmp/pip-build-env-bi1ma0qt/overlay/lib/python3.7/site-packages/sipbuild/project.py", line 479, in setup
            self.apply_user_defaults(tool)
          File "project.py", line 62, in apply_user_defaults
            super().apply_user_defaults(tool)
          File "/tmp/pip-build-env-bi1ma0qt/overlay/lib/python3.7/site-packages/pyqtbuild/project.py", line 89, in apply_user_defaults
            super().apply_user_defaults(tool)
          File "/tmp/pip-build-env-bi1ma0qt/overlay/lib/python3.7/site-packages/sipbuild/project.py", line 225, in apply_user_defaults
            self.builder.apply_user_defaults(tool)
          File "/tmp/pip-build-env-bi1ma0qt/overlay/lib/python3.7/site-packages/pyqtbuild/builder.py", line 69, in apply_user_defaults
            "specify a working qmake or add it to PATH")
        sipbuild.pyproject.PyProjectOptionException
        ----------------------------------------
    ERROR: Command errored out with exit status 1: /usr/bin/python3 /usr/lib/python3.7/site-packages/pip/_vendor/pep517/_in_process.py prepare_metadata_for_build_wheel /tmp/tmpngmrw6gt Check the logs for full command output.
    

    What should I do now to have these issues fixed?

    I fixed the issue "specify a working qmake or add it to PATH" by installing qt on my 64-Bit Raspberry Pi OS system using sudo apt-get install qt5-default. qmake wasn't previously on my PATH as I didn't have QT5 installed.


Log in to reply